local M = {}

local gear_position
local cooldown
local secondary_delay
local flaps
local flapsSettings = {}
local strobeLight

local function onReset()
	flapsSettings[1] = 0
	flapsSettings[2] = 0.2
	flapsSettings[3] = 0.6
	flapsSettings[4] = 1
	gear_position = 0
	cooldown = 0
	flaps = 1
	secondary_delay = 4.1
	electrics.values['gear_actuate'] = gear_position
	electrics.values['gear_secondary'] = gear_position
	electrics.values['flaps'] = flapsSettings[flaps]
	electrics.values['navLights'] = 0
	electrics.values['strobeLight'] = 0
	strobeLight = false
	controller.getControllerSafe('noseGearCoupler').reset()
end

local function onInit()
	onReset()
end

local function gear(VALUE)
	if gear_position == 1 then
		gear_position = 0
		controller.getControllerSafe('noseGearCoupler').detachGroup()
	else
		gear_position = 1
		controller.getControllerSafe('noseGearCoupler').reset()
	end
	electrics.values['gear_actuate'] = gear_position
end

local function toggleNavLights()
	electrics.values['navLights'] = electrics.values['navLights'] == 1 and 0 or 1
end

local strobeLightTimer = 0

local function updateGFX(dt)
	if electrics.values['navLights'] == 0 and not strobeLight then 
		return
	end

	strobeLightTimer = strobeLightTimer + dt
	if strobeLight then
		if strobeLightTimer > 0.2 then
			strobeLight = false
			strobeLightTimer = 0
			electrics.values['strobeLight'] = strobeLight and 1 or 0
		end
	elseif strobeLightTimer > 1.2 then
		strobeLight = true
		strobeLightTimer = 0
		electrics.values['strobeLight'] = strobeLight and 1 or 0
	end
end

M.gear = gear
M.setFlaps = setFlaps
M.toggleNavLights = toggleNavLights
M.onReset = onReset
M.onInit = onInit
M.updateGFX = updateGFX
return M